/***************************************************************
 * Proyecto CoMVeT                                             *
 * Proyecto de fin de carrera de Daniel Hctor Stolfi Rosso    *
 * Escuela Tcnica Superior de Ingeniera Informtica          *
 * Universidad de Mlaga - 2010                                *
 *                                                             *
 * Grafica.h                                                   *
 * Clase que gestiona la grfica de seales (cabecera)         *
 *                                                             *
 ***************************************************************/
//---------------------------------------------------------------------------

#ifndef GraficaH
#define GraficaH
#include <Graphics.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
/* Seales grfica */
typedef enum SenalesGrafica {
   SG_Ninguna = 0, SG_Centro, SG_Adelante, SG_Atras, SG_Izquierda, SG_Derecha
} SG_SenalesGrafica_t;
/* Nmero de grficas */
static const unsigned short NUM_GRAFICAS=6;
/* Nmero de puntos */
static const unsigned short NUM_PUNTOS=748;
/* Desplazamiento de avance */
static const unsigned short DESPLAZAMIENTO=50;
/* Posiciones grficas */
static const unsigned short y0[NUM_GRAFICAS] = {20,40,60,80,100,120};
/* Colores grficas */
static const TColor color[NUM_GRAFICAS] = {clBlack, clBlue, clRed, clGreen, clFuchsia, clTeal};

class TGrafica {
private:
   TPaintBox *pb;                               // PaintBox sobre la que se dibujar
   TImage *im;                                  // Image con las referencias
   unsigned int y[NUM_GRAFICAS][NUM_PUNTOS];    // Matriz con los valores a dibujar
   unsigned short x;                            // Coordenada x del ltimo valor
   bool habilitada;                             // Almacena el estado de la grfica

public:
   /* Constructor
      Recibe el puntero al PaintBox que se utilizar como grfica y
      a la imagen con las referencias */
   TGrafica(TPaintBox *pb, TImage *im);

   /* estado(bool habilitada)
      Habilita / inhabilita la grfica */
   void estado(bool habilitada);

   /* limpiar()
      Vaca el contenido de la grfica */
   void limpiar();

   /* anadir(unsigned short* valores)
      Aade una nueva lista de valores pasados en el parmetro */
   void anadir(unsigned short* valores);

private:
   /* Dibuja sobre el PaintBox */
   void __fastcall pintar(TObject *Sender);

};

#endif
