/***************************************************************
 * Proyecto CoMVeT                                             *
 * Proyecto de fin de carrera de Daniel Hctor Stolfi Rosso    *
 * Escuela Tcnica Superior de Ingeniera Informtica          *
 * Universidad de Mlaga - 2010                                *
 *                                                             *
 * Main.h                                                      *
 * Interfaz grfica y punto de entrada del programa (cabecera) *
 *                                                             *
 ***************************************************************/
//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "cgauges.h"
#include <ToolWin.hpp>
#include <Graphics.hpp>
#include <ImgList.hpp>
#include <ActnList.hpp>
#include <ActnMan.hpp>
#include <PlatformDefaultStyleActnCtrls.hpp>
#include <StdActns.hpp>
#include "Tipos.h"
#include "Conexion.h"
#include "Actuador.h"
#include "Grafica.h"
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
/* Nmero de electrodos en el casco */
const unsigned short NUM_ELECTRODOS = 16;
/* Colores texto registro segn tipo */
const TColor COLORES_REGISTRO[] = {clWindowText, clBlue, clRed};
/* Numero de estados posibles para los electrodos del casco */
const unsigned short NUM_ESTADOS = 5;
/* Colores para cada estado posible de los electrodos del casco */
const TColor ESTADOS[NUM_ESTADOS] = {clBlack, clRed, TColor(33023), clYellow, clLime};
/* Puerto por defecto del emulador */
const UnicodeString PUERTO_EMULADOR = "1726";
//---------------------------------------------------------------------------
class TFMain : public TForm
{
__published:	// IDE-managed Components
   TRichEdit *RichEditRegistro;
   TPanel *PanelSuperior;
   TPanel *PanelConectar;
   TRadioGroup *RadioGroupMotor;
   TGroupBox *GroupBoxServidor;
   TEdit *EditIp1;
   TEdit *EditPuerto;
   TBitBtn *BitBtnConectar;
   TBitBtn *BitBtnDesconectar;
   TLabel *LabelServidor;
   TLabel *LabelPuerto;
   TCGauge *CGaugeFuerza;
   TImage *ImageFlechasArribaAbajo;
   TToolBar *ToolBarPrincipal;
   TToolButton *ToolButtonManual;
   TToolButton *ToolButtonCasco;
   TToolButton *ToolButtonActuador;
   TImageList *ImageListFlechasArribaAbajo;
   TActionManager *ActionManager;
   TAction *ActionCasco;
   TAction *ActionManual;
   TPanel *PanelContenedor;
   TPanel *PanelSensores;
   TPanel *PanelGrafica;
   TImage *ImageCasco;
   TPanel *PanelIndicadores;
   TLabel *LabelEstado;
   TCGauge *CGaugeBateria;
   TAction *ActionActuador;
   TProgressBar *ProgressBarSenal;
   TAction *ActionConectar;
   TAction *ActionDesconectar;
   TPaintBox *PaintBoxGrafica;
   TEdit *EditIp2;
   TEdit *EditIp3;
   TEdit *EditIp4;
   TShape *ShapeElectodo01;
   TShape *ShapeElectodo02;
   TShape *ShapeElectodo03;
   TShape *ShapeElectodo04;
   TShape *ShapeElectodo05;
   TShape *ShapeElectodo06;
   TShape *ShapeElectodo07;
   TShape *ShapeElectodo08;
   TShape *ShapeElectodo09;
   TShape *ShapeElectodo10;
   TShape *ShapeElectodo11;
   TShape *ShapeElectodo12;
   TShape *ShapeElectodo13;
   TShape *ShapeElectodo14;
   TShape *ShapeElectodo15;
   TShape *ShapeElectodo16;
   TImageList *ImageListCasco;
   TAction *ActionCargaPerfil;
   TOpenDialog *OpenDialog;
   TImage *ImageGrafica;
   TLabel *LabelTiempoConexionEtq;
   TLabel *LabelTiempoConexion;
   TPanel *PanelRegistro;
   TToolBar *ToolBarRegistro;
   TToolButton *ToolButtonLimpiar;
   TToolButton *ToolButtonGuardar;
   TToolButton *ToolButtonEstados;
   TToolButton *ToolButtonAyuda;
   TToolButton *ToolButtonAcercaDe;
   TAction *ActionLimpiar;
   TAction *ActionGuardar;
   TAction *ActionEstados;
   TAction *ActionAyuda;
   TAction *ActionAcercaDe;
   TSaveDialog *SaveDialog;
   TImageList *ImageListToolBars;
   TImage *ImageFlechasIzquierdaDerecha;
   TImageList *ImageListFlechasIzquierdaDerecha;
   TCGauge *CGaugeGiro;
   TProgressBar *ProgressBarEntrenamiento;
   TGroupBox *GroupBoxTrackBar;
   TTrackBar *TrackBarUmbralAvRet;
   TTrackBar *TrackBarAvance;
   TTrackBar *TrackBarUmbralGiro;
   TTrackBar *TrackBarRetroceso;
   TSpeedButton *SpeedButtonCentrarCasco;
   TAction *ActionCentrarCasco;
   TPanel *PanelPerfil;
   TLabel *LabelFicheroPerfil;
   TSpeedButton *SpeedButtonPerfil;
   TShape *ShapeIndicadorGiro;
   TShape *ShapeIndicadorFuerza;
   TPanel *PanelCalibrandoAcelerometros;
   TLabel *LabelCalibrando;
   TLabel *LabelPermanezca;
   void __fastcall RadioGroupMotorClick(TObject *Sender);
   void __fastcall ActionManualExecute(TObject *Sender);
   void __fastcall ActionCascoExecute(TObject *Sender);
   void __fastcall ActionConectarExecute(TObject *Sender);
   void __fastcall ActionDesconectarExecute(TObject *Sender);
   void __fastcall ImageFlechasArribaAbajoMouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
   void __fastcall ImageFlechasIzquierdaDerechaMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
   void __fastcall ImageFlechasArribaAbajoMouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
   void __fastcall ActionActuadorExecute(TObject *Sender);
   void __fastcall FormDestroy(TObject *Sender);
   void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
   void __fastcall EditPuertoExit(TObject *Sender);
   void __fastcall EditIp1Exit(TObject *Sender);
   void __fastcall ActionCargaPerfilExecute(TObject *Sender);
   void __fastcall TrackBarUmbralAvRetChange(TObject *Sender);
   void __fastcall TrackBarUmbralGiroChange(TObject *Sender);
   void __fastcall TrackBarAvanceChange(TObject *Sender);
   void __fastcall TrackBarRetrocesoChange(TObject *Sender);
   void __fastcall ActionLimpiarExecute(TObject *Sender);
   void __fastcall ActionEstadosExecute(TObject *Sender);
   void __fastcall ActionGuardarExecute(TObject *Sender);
   void __fastcall ActionAyudaExecute(TObject *Sender);
   void __fastcall ActionAcercaDeExecute(TObject *Sender);
   void __fastcall ActionCentrarCascoExecute(TObject *Sender);

private:	// User declarations

   TConexion *con;              // Puntero a la instancia de conexin
   TActuador *actuador;         // Puntero a la instancia de actuador
   TGrafica *grafica;           // Puntero a la instancia de grfica
   bool conectado;              // Indica si se encuentra conectado
   bool continuar;              // Control del bucle de lectura de eventos
   bool manual;                 // Indica que se encuentra en el modo manual
   bool inicializarGiro;        // Indica la peticin pendiente de puesta a cero del acelermetro
   bool cargarPerfil;           // Indica la peticin pendiente de carga de perfil
   bool perfilCargado;          // Indica si se ha cargado un perfil
   UnicodeString ficheroPerfil; // Cadena con la ruta al fichero de perfil
   UnicodeString ficheroINI;    // Cadena con la ruta al fichero INI
   GI_Giro_t giroManual;        // Indica direccin de giro
   unsigned short imgCasco;     // ndice de la imagen del casco actual
   unsigned short imgFlechasAB; // ndice de la imagen de direccin actual (Arriba-Abajo)
   unsigned short imgFlechasID; // ndice de la imagen de direccin actual (Izquierda-Derecha)
   UnicodeString VERSION;       // Versin del programa
   UnicodeString BUILD;         // Versin del build
   UnicodeString FECHA_VERSION; // Fecha del programa
   UnicodeString NOMBRE;        // Nombre del programa
   UnicodeString PROYECTO;      // Nombre del proyecto
   UnicodeString AUTOR;         // Nombre del autor

   /* registro(RG_Registro_t tipo, UnicodeString cadena)
      Registra el mensaje que se recibe en el parmetro cadena
      del tipo indicado en el parmetro tipo */
   void registro(RG_Registro_t tipo, UnicodeString cadena);

   /* imagen(AC_Accion_t ac, GI_Giro_t gi, bool activoAB, bool activoID)
      Cambia la imagen segn la accin, giro y los estados de actividad recibidos
      como parmetro */
   void imagen(AC_Accion_t ac, GI_Giro_t gi, bool activoAB, bool activoID);

   /* estado(ES_Estado_t es)
      Representa en la interfaz grfica el estado que se recibe como parmetro */
   void estado(ES_Estado_t es);

   /* senal(SN_Senal_t sn)
      Representa en la interfaz grfica el valor de la seal de enlace con el casco
      que se recibe por parmetro a travs del parmetro */
   void senal(SN_Senal_t sn);

   /* bateria(int carga, int maxima)
      Representa en la interfaz grfica el nivel de carga de batera.
      Recibe como parmetro el valor de la carga y la carga mxima posible */
   void bateria(int carga, int maxima);

   /* fuerza(unsigned short fu)
      Representa en la interfaz grfica el nivel de fuerza del evento detectado
      que se proporciona como parmetro (0 - 10) */
   void fuerza(unsigned short fu);

   /* desviacion(short inc)
      Representa en la interfaz grfica el nivel de fuerza del evento detectado
      que se proporciona como parmetro (0 - 10) */
   void desviacion(short inc);

   /* entrenamiento(UnicodeString fichero, float nivel)
      Representa en la interfaz grfica el fichero del perfil de usuario y
      el porcentual del nivel de entrenamiento (0.0 - 100.0) */
   void entrenamiento(UnicodeString fichero, float nivel);

   /* formulario()
      Configura el formulario segn el estado de la conexin
      y si se encuentra en el modo manual */
   void formulario();

   /* editsServidor(bool activo)
      Activa/desactiva los edits con los parmetros del servidor */
   void editsServidor(bool activo);

   /* labelsTiempoConexion(bool activo)
      Activa/desactiva las etiquetas de tiempo de conexin */
   void labelsTiempoConexion(bool activo);

   /* labelsFicheroPerfil(bool activo)
      Activa/desactiva las etiquetas del fichero del perfil */
   void labelsFicheroPerfil(bool activo);

   /* accionManual(AC_Accion_t ac, GI_Giro_t gi)
      Ejecuta de forma manual la accin compuesta por los parmetros pasados */
   void accionManual(AC_Accion_t ac, GI_Giro_t gi);

   /* imagenCasco(bool estado_casco, int *contactos)
      Representa en la interfaz grfica los estados de los contactos
      recibidos en el array contactos o bien los inhabilita a todos mediante el
      valor del parmetro estado_casco */
   void imagenCasco(bool estado_casco, int *contactos);

   /* tiempoConexion(float tiempo)
      Actualiza la etiqueta con el tiempo de conexin */
   void tiempoConexion(float tiempo);

public:
   /* Constructor */
	__fastcall TFMain(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TFMain *FMain;
//---------------------------------------------------------------------------
#endif
